/* Shopper
 * Copyright (C) 2008 David Greaves
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */

#include "shopperList.h"

namespace Shopper
{
	// declare
	class CategoryDialog;
	
	// private helper class
	class CatView : public Gtk::HBox
	{
	public:
		CatView(CategoryDialog* myD, Category &it, List &l) ;
		~CatView() ;

		void show();
		bool name_show_edit(GdkEventButton* ev);
		bool name_show_label(GdkEventFocus* ev);
		bool name_show_label(GdkEventButton* ev);
		void name_show_label();
		void set_top();
		void set_bottom();
		void move_up();
		void move_down();
	private:
		Gtk::Image    i_up;
		Gtk::Image    i_down;
		
		// member data
		Category     *mycat;
		List         *mylist;
		CategoryDialog *myD;
		// UI
		Gtk::Label    name_l;
		Gtk::EventBox name_b;
		Gtk::Button   b_up;
		Gtk::Button   b_down;
		bool          at_top;
		bool          at_bottom;

		Gtk::Entry    *name_edit;
	};
	
// private base for adding/editing an Category
	class CategoryDialog : public Gtk::Dialog
	{
		friend class CatView;
	public:
		int run();    // Calls Dialog run method and does add/edit
	protected:
		CategoryDialog(Shopper::List*, Shopper::Category*);

		// Data
		Shopper::List               *mylist;
		Shopper::Category           *mycat;
		bool                        editing; // flag if editing a category

		// UI
		Gtk::ScrolledWindow         sw;
		Gtk::VBox                   vb;
	};

// Public classes for add/edit
	class CategoryEdit : public CategoryDialog
	{
	public:
		CategoryEdit(Shopper::List* mylist, Shopper::Category* cat);
	};
	class CategoryAdd : public CategoryDialog
	{
	public:
		CategoryAdd(Shopper::List* mylist);
	};
}
